from WikiPlugin import *
from AppData import *
from WikiLoaderXML import *
from WikiLoaderHtml import *
import os
import time
import codecs

#
# Exports all of your NoteStudio books to text files in the
#         C:\Temp\Exported NoteStudio Books
# directory
# 
# (Change this directory in the code if you want to export
# to somewhere else)
# 
# The pages are exported in their original wiki markup, so 
# they should be more or less readable by bLADE Wiki.
# 
# See the 'Help' documentation in the Windows version of the
# wiki for more information.

# Version History
#
# 0.1 Original script from Dale Lane. Exports all books
# 0.2 Updated by Allan Davies to do following
#     a. Allow selection of one or all books
#     b. Renames Notestudios 'Home Page' to 'homepage' which bLADEWiki requires
# 0.3 Updated by Laurent Burgbacher to do following
#     a. write in UTF-8 (required by bLADEWiki)
#     b. write \r\n end of lines (for ease of reading the page source)

def getName():
        return "Export all books to WM5"


def getVendorName():
        return "Dale Lane"


def getVendorVersionString():
        return "0.3"


def getDescription():
        return "Export all NS books in wiki markup format"


def preExecute():
        STAGE_NAME = "preExecute"
        return []

def execute( parameterList ):
        STAGE_NAME = "execute"

        bThrowException = False

        loader = WikiLoaderHtml()

        numBooks = theAppData.library.getNumBooks()

        for i in range( numBooks ):
                book = theAppData.library.getBook( i )

                #Only process unencrypted books isLocked=0 (encrypted is value of 1)
                if book.isLocked()==0:

                    loader.currentBook = book
                    loader.generatePageToFilenameMap()
    
                    bookName = book.getDisplayName()
    
                    outputDirectory = "C:/Temp/Exported NoteStudio Books/" + bookName + "/"
    
                    if not os.path.exists(outputDirectory):
                            os.makedirs(outputDirectory)
    
                    numPages = book.getNumPages()
    
                    for j in range( numPages ):
    
                            page = book.getPage( j )
    
                            pageName = page.getName()
                            if pageName=='Home Page':
                                                        filename = outputDirectory + "homepage.txt"
                            else:
                                pageName = pageName.replace(" ", "%20");
                                pageName = pageName.replace("?", "%3F");
                                pageName = pageName.replace(":", "%3A");
                                pageName = pageName.replace("/", "%2F");
                                filename = outputDirectory + pageName + ".txt"
    
                            pageContents = page.getText()
    
                            f = codecs.open(filename, encoding="utf-8", mode="w")
                            pageContents = pageContents.replace("\r\n", "***brbn***")
                            pageContents = pageContents.replace("\n", "\r\n")
                            pageContents = pageContents.replace("***brbn***", "\r\n")
                            f.write(pageContents.decode("latin-1"))
                            f.flush()
                            f.close()

        if bThrowException:
                raise WikiPluginException( STAGE_NAME, "Some error string describing the problem" )

        dlg = wxMessageDialog( None, "plugin finished exporting books ", "Finished!", wxOK )
        dlg.ShowModal()

def postExecute():
        STAGE_NAME = "postExecute"
        pass


